Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jasig.portal.groups
Interface ICompositeGroupService

All Superinterfaces:
  IComponentGroupService

All Known Subinterfaces:
  IIndividualGroupService

All Known Implementing Classes:
  ReferenceCompositeGroupService, ReferenceIndividualGroupService

    public interface ICompositeGroupService

extends IComponentGroupService

Defines an api for discovering entry points into a composite groups system consisting of component group services. These entry points are represented by `IGroupMembers`. The role of the `IGroupMember`is somewhat analogous to that of an `InitialContext` in JNDI. Once a client gets an `IGroupMember`, subsequent requests for navigating the system or maintaining groups go thru the `IGroupMember` api and are serviced by the individual component services.

Version:
  $Revision: 1.5 $
Author:
  Dan Ellentuck

Method Summary
`java.util.Iterator` | `findContainingGroups(IGroupMember gm)` Returns the groups that contain the `IGroupMember`.
`IEntityGroup` | `findGroup(java.lang.String key)` Returns a pre-existing `IEntityGroup` or null if it does not exist.
`ILockableEntityGroup` | `findGroupWithLock(java.lang.String key, java.lang.String owner)` Returns a pre-existing `IEntityGroup` or null if it does not exist.
`IEntity` | `getEntity(java.lang.String key, java.lang.Class type)` Returns an `IEntity` representing a portal entity.
`IEntity` | `getEntity(java.lang.String key, java.lang.Class type, java.lang.String service)` Returns an `IEntity` representing a portal entity.
`IGroupMember` | `getGroupMember(EntityIdentifier underlyingEntityIdentifier)` Returns an `IGroupMember` representing either a group or a portal entity, based on the `EntityIdentifier`, which refers to the UNDERLYING entity for the `IGroupMember`.
`IGroupMember` | `getGroupMember(java.lang.String key, java.lang.Class type)` Returns an `IGroupMember` representing either a group or a portal entity.
`IEntityGroup` | `newGroup(java.lang.Class type, javax.naming.Name serviceName)` Returns a new `IEntityGroup` for the given Class with an unused key from the named service.
`EntityIdentifier[]` | `searchForEntities(java.lang.String query, int method, java.lang.Class type)` Find EntityIdentifiers for entities whose name matches the query string according to the specified method and is of the specified type
`EntityIdentifier[]` | `searchForEntities(java.lang.String query, int method, java.lang.Class type, IEntityGroup ancestor)` Find EntityIdentifiers for entities whose name matches the query string according to the specified method, is of the specified type and descends from the specified group
`EntityIdentifier[]` | `searchForGroups(java.lang.String query, int method, java.lang.Class leaftype)` Find EntityIdentifiers for groups whose name matches the query string according to the specified method and matches the provided leaf type
`EntityIdentifier[]` | `searchForGroups(java.lang.String query, int method, java.lang.Class leaftype, IEntityGroup ancestor)` Find EntityIdentifiers for groups whose name matches the query string according to the specified method, has the provided leaf type and descends from the specified group

Methods inherited from interface org.jasig.portal.groups.IComponentGroupService
`getComponentServices, getServiceName, isLeafService, setServiceName`

Method Detail

### findContainingGroups

    java.util.Iterator findContainingGroups(IGroupMember gm)
                                            throws GroupsException

  Returns the groups that contain the `IGroupMember`.

  Parameters:
    `gm` - IGroupMember
  Throws:
    `GroupsException`

### findGroup

    IEntityGroup findGroup(java.lang.String key)
                           throws GroupsException

  Returns a pre-existing `IEntityGroup` or null if it does not exist.

  Throws:
    `GroupsException`

### findGroupWithLock

    ILockableEntityGroup findGroupWithLock(java.lang.String key,
                                           java.lang.String owner)
                                           throws GroupsException

  Returns a pre-existing `IEntityGroup` or null if it does not exist.

  Throws:
    `GroupsException`

### getEntity

    IEntity getEntity(java.lang.String key,
                      java.lang.Class type)
                      throws GroupsException

  Returns an `IEntity` representing a portal entity. This does not guarantee that the entity actually exists.

  Throws:
    `GroupsException`

### getEntity

    IEntity getEntity(java.lang.String key,
                      java.lang.Class type,
                      java.lang.String service)
                      throws GroupsException

  Returns an `IEntity` representing a portal entity. This does not guarantee that the entity actually exists.

  Throws:
    `GroupsException`

### getGroupMember

    IGroupMember getGroupMember(java.lang.String key,
                                java.lang.Class type)
                                throws GroupsException

  Returns an `IGroupMember` representing either a group or a portal entity. If the parm `type` is the group type, the `IGroupMember` is an `IEntityGroup`. Otherwise it is an `IEntity`.

  Throws:
    `GroupsException`

### getGroupMember

    IGroupMember getGroupMember(EntityIdentifier underlyingEntityIdentifier)
                                throws GroupsException

  Returns an `IGroupMember` representing either a group or a portal entity, based on the `EntityIdentifier`, which refers to the UNDERLYING entity for the `IGroupMember`.

  Throws:
    `GroupsException`

### newGroup

    IEntityGroup newGroup(java.lang.Class type,
                          javax.naming.Name serviceName)
                          throws GroupsException

  Returns a new `IEntityGroup` for the given Class with an unused key from the named service.

  Throws:
    `GroupsException`

### searchForEntities

    EntityIdentifier[] searchForEntities(java.lang.String query,
                                         int method,
                                         java.lang.Class type)
                                         throws GroupsException

  Find EntityIdentifiers for entities whose name matches the query string according to the specified method and is of the specified type

  Throws:
    `GroupsException`

### searchForEntities

    EntityIdentifier[] searchForEntities(java.lang.String query,
                                         int method,
                                         java.lang.Class type,
                                         IEntityGroup ancestor)
                                         throws GroupsException

  Find EntityIdentifiers for entities whose name matches the query string according to the specified method, is of the specified type and descends from the specified group

  Throws:
    `GroupsException`

### searchForGroups

    EntityIdentifier[] searchForGroups(java.lang.String query,
                                       int method,
                                       java.lang.Class leaftype)
                                       throws GroupsException

  Find EntityIdentifiers for groups whose name matches the query string according to the specified method and matches the provided leaf type

  Throws:
    `GroupsException`

### searchForGroups

    EntityIdentifier[] searchForGroups(java.lang.String query,
                                       int method,
                                       java.lang.Class leaftype,
                                       IEntityGroup ancestor)
                                       throws GroupsException

  Find EntityIdentifiers for groups whose name matches the query string according to the specified method, has the provided leaf type and descends from the specified group

  Throws:
    `GroupsException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD